###
### "THE BEER-WARE LICENSE":
### Alberto Ramos wrote this file. As long as you retain this 
### notice you can do whatever you want with this stuff. If we meet some 
### day, and you think this stuff is worth it, you can buy me a beer in 
### return. <alberto.ramos@cern.ch>
###
### file:    Scalar.jl
### created: Tue Oct  5 11:53:31 2021
###                               

module Scalar

using CUDA, Random
using ..Space
using ..Groups
using ..YM

import Base.show

struct ScalarParam{N,T}
    kap::NTuple{N,T}
    eta::NTuple{N,T}
end
function Base.show(io::IO, sp::ScalarParam{N,T}) where {N,T}

    println(io, "Number of scalar fields: ", N)
    print(io, "Kappas: ")
    for i in 1:N
        print(io, " ", sp.kap[i])
    end
    println("\netas:   ")
    for i in 1:N
        print(io, " ", sp.kap[i])
    end
    println("\n")

end

struct ScalarWorkspace{T}
    frc1
    mom
    function ScalarWorkspace(::Type{T}, lp::SpaceParm) where {T <: AbstractFloat}

        return ScalarWorkspace(vector_field(SU2fund{T}, lp),
                               vector_field(SU2fund{T}, lp))
    end
end
export ScalarWorkspace

include("ScalarAction.jl")
export scalar_action

include("ScalarForce.jl")
export force_scalar

end
